 processor 6502
 include "7800.h"
 ;include "macro.h"
 include "7800basic_variable_redefs.h"

 ;************ 7800 overall RAM map **************

 ;         40-FF         zero page RAM
 ;        140-1FF        RAM (stack)
 ;       1800-203F       RAM
 ;       2100-213F       RAM
 ;       2200-27FF       RAM

 ;************ 7800basic RAM usage map **************

 ;         40-FF         numerous defines, listed below
 ;        140-1FF        RAM (stack)

 ;       1800-187F       DLL
 ;       1880-1F9B       DLs 
 ;       1F9C-1FFF       Free

 ;       2000-203F       Reserved
 ;       2100-213F       Reserved
 ;       2200-27FF       Free

eeprombuffer    = $1FE0
DLLMEM          = $1800
VALBUFFER       = $2000 ; to $202F  ** never let VALBUFFER straddle pages
framecounter    = $2030
countdownseconds = $2031
score0          = $2034 ; $2035 $2036
score1          = $2037 ; $2038 $2039
pausebuttonflag = $203A
valbufend       = $203B
valbufendsave   = $203C
finescrollx     = $203D
finescrolly     = $203E
joybuttonmode   = $203F ; used to track any joysticks that were changed to one-button mode

pausestate     = $2100
dlzero         = $2101 ; force end of $2100 DL, which we use in vblank and overscan
sINPT1         = $2102 ; save register for joy button joy0
sINPT3         = $2103 ; save register for joy button joy1
currentbank    = $2104
currentrambank = $2105
charactermode  = $2106
sCTRL          = $2107
pokeydetected  = $2108
paldetected    = $2109
avoxdetected   = $210A
sCHARBASE      = $210B ; save register for CHARBASE

hsdevice       = $210C
hsdifficulty   = $210D
hserror        = $210E
hsgameslot     = $210F
hsnewscoreline = $2110
hsnewscorerank = $2111
HSRAMTable     = $2112 ; to $212F (30 bytes) Format: III*5, SSS*5
HSRAMInitials  = $2112 ; see above
HSRAMScores    = $2121 ; see above

ssCTRL         = $2131
ssCHARBASE     = $2132
hsdisplaymode  = $2133
gamedifficulty = $2134
hsinitialpos   = $2135
hsinitialhold  = $2136
hscursorx      = $2137
hsjoydebounce  = $2138
hsswcha        = $2139
hsinpt1        = $213A
hscolorchaseindex = $213B
 ;213F is last


rand       = $40
rand16     = $41
temp1      = $42
temp2      = $43
temp3      = $44
temp4      = $45
temp5      = $46
temp6      = $47
temp7      = $48
temp8      = $49
temp9      = $4a

visibleover    = $4b

pokeybase      = $4c
pokeybaselo    = $4c
pokeybasehi    = $4d

sfx1pointlo  = $4e
sfx1pointhi  = $4f
sfx2pointlo  = $50
sfx2pointhi  = $51
sfx1priority = $52
sfx2priority = $53
sfx1poffset  = $54
sfx2poffset  = $55
sfx1frames   = $56
sfx2frames   = $57
sfx1tick     = $58
sfx2tick     = $59
tempmath     = $5a
pokey1pointlo  = $5b
pokey1pointhi  = $5c
pokey2pointlo  = $5d
pokey2pointhi  = $5e
pokey3pointlo  = $5f
pokey3pointhi  = $60
pokey4pointlo  = $61
pokey4pointhi  = $62
pokey1priority = $63
pokey1offset   = $64
pokey2priority = $65
pokey2offset   = $66
pokey3priority = $67
pokey3offset   = $68
pokey4priority = $69
pokey4offset   = $6a
pokey1frames   = $6b
pokey1tick     = $6c
pokey2frames   = $6d
pokey2tick     = $6e
pokey3frames   = $6f
pokey3tick     = $70
pokey4frames   = $71
pokey4tick     = $72

dlpnt      = $73 ; to $74
dlend      = $75 ; to $91 - for 28 possible visible dll entries
dlendsave  = $92 ; to $ae - for 28 possible visible dll entries

speech_addr    = $af
speech_addr_hi = $b0
avoxenable     = $b1

HSGameTableLo = $b2
HSGameTableHi = $b3
HSVoxHi       = $b4
HSVoxLo       = $b5

; ** RESERVED $B2 to $E5 - 54 free ZP locations

A = $e6
a = $e6
B = $e7
b = $e7
C = $e8
c = $e8
D = $e9
d = $e9
E = $ea
e = $ea
F = $eb
f = $eb
G = $ec
g = $ec
H = $ed
h = $ed
I = $ee
i = $ee
J = $ef
j = $ef
K = $f0
k = $f0
L = $f1
l = $f1
M = $f2
m = $f2
N = $f3
n = $f3
O = $f4
o = $f4
P = $f5
p = $f5
Q = $f6
q = $f6
R = $f7
r = $f7
S = $f8
s = $f8
T = $f9
t = $f9
U = $fa
u = $fa
V = $fb
v = $fb
W = $fc
w = $fc
X = $fd
x = $fd
Y = $fe
y = $fe
Z = $ff
z = $ff

; var0-var99 variables use the top of the stack. The stack still will have 92 bytes free.
var0 = $140
var1 = $141
var2 = $142
var3 = $143
var4 = $144
var5 = $145
var6 = $146
var7 = $147
var8 = $148
var9 = $149
var10 = $14a
var11 = $14b
var12 = $14c
var13 = $14d
var14 = $14e
var15 = $14f
var16 = $150
var17 = $151
var18 = $152
var19 = $153
var20 = $154
var21 = $155
var22 = $156
var23 = $157
var24 = $158
var25 = $159
var26 = $15a
var27 = $15b
var28 = $15c
var29 = $15d
var30 = $15e
var31 = $15f
var32 = $160
var33 = $161
var34 = $162
var35 = $163
var36 = $164
var37 = $165
var38 = $166
var39 = $167
var40 = $168
var41 = $169
var42 = $16a
var43 = $16b
var44 = $16c
var45 = $16d
var46 = $16e
var47 = $16f
var48 = $170
var49 = $171
var50 = $172
var51 = $173
var52 = $174
var53 = $175
var54 = $176
var55 = $177
var56 = $178
var57 = $179
var58 = $17a
var59 = $17b
var60 = $17c
var61 = $17d
var62 = $17e
var63 = $17f
var64 = $180
var65 = $181
var66 = $182
var67 = $183
var68 = $184
var69 = $185
var70 = $186
var71 = $187
var72 = $188
var73 = $189
var74 = $18a
var75 = $18b
var76 = $18c
var77 = $18d
var78 = $18e
var79 = $18f
var80 = $190
var81 = $191
var82 = $192
var83 = $193
var84 = $194
var85 = $195
var86 = $196
var87 = $197
var88 = $198
var89 = $199
var90 = $19a
var91 = $19b
var92 = $19c
var93 = $19d
var94 = $19e
var95 = $19f
var96 = $1a0
var97 = $1a1
var98 = $1a2
var99 = $1a3

